using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Utilitaires;
using USB_HID;
using System.Threading;
using System.Diagnostics;
using System.Runtime.InteropServices;

namespace RBC9___HID
{



    public partial class FormHID : Form
    {
       MX1000 MyMX1000 = new MX1000();
       SpaceNavigator myNav;

        private int NumIco = 0;
        private System.Drawing.Icon[] MyIcon = new Icon[5];

        private void Icon_Init()
        {
            System.Reflection.Assembly MyAssembly = System.Reflection.Assembly.GetExecutingAssembly();
            MyIcon[0] = new System.Drawing.Icon(MyAssembly.GetManifestResourceStream("RBC9___HID.iconStop.ico"));
            MyIcon[1] = new System.Drawing.Icon(MyAssembly.GetManifestResourceStream("RBC9___HID.icon2.ico"));
            MyIcon[2] = new System.Drawing.Icon(MyAssembly.GetManifestResourceStream("RBC9___HID.icon3.ico"));
            MyIcon[3] = new System.Drawing.Icon(MyAssembly.GetManifestResourceStream("RBC9___HID.icon4.ico"));
            MyIcon[4] = new System.Drawing.Icon(MyAssembly.GetManifestResourceStream("RBC9___HID.icon1.ico"));

            Icon_Draw(0);

        }

        private void Icon_Bcl()
        {
            if (++NumIco > 4)
            {
                NumIco = 1;
            }
            Icon_Draw(NumIco);
        }

        private void Icon_Draw(int vNumIco)
        {
            notifyIcon.Icon = MyIcon[vNumIco];
        }

        private void SwitchMin(bool vUsbMin)
        {

            if (vUsbMin)
            {
                this.Hide();
                MenuNotify.MenuItems[1].Text = "Show";

            }
            else
            {

                this.Show();
                this.Activate();
                this.Focus();
                MenuNotify.MenuItems[1].Text = "Hide";

            }

        }

        public FormHID()
        {
            InitializeComponent();

            Icon_Init();

        }


        private void IconTimer_Tick(object sender, EventArgs e)
        {
            bool AnimIcon = false;

            MenuNotify.MenuItems[0].Checked = MyMX1000.AutoApply;
            if (MyMX1000.Profil != "")
            {
                MenuNotify.MenuItems[0].Text = "MX 1000 (" + MyMX1000.Profil + ")";
                AnimIcon = true;
            }
            else
            {
                MenuNotify.MenuItems[0].Text = "MX 1000";

            }

            if (AnimIcon)
                Icon_Bcl();
            else
                Icon_Draw(0);
        }


        private void menu_Close_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void notifyIcon_MouseDoubleClick(object sender, MouseEventArgs e)
        {
            bool CurVis = this.Visible;

            SwitchMin(CurVis);
        }

        private void FormHID_Load(object sender, EventArgs e)
        {
            demar();
        }

        private void FormHID_Activated(object sender, EventArgs e)
        {
            
        }

        private void menu_Config_Click(object sender, EventArgs e)
        {
            bool CurVis = this.Visible;

            SwitchMin(CurVis);
        }

        private void menuItem1_Click(object sender, EventArgs e)
        {
            ParamMX1000 MyParam = new ParamMX1000();
            MyMX1000.Stop();
            MyParam.ShowDialog();
            MyMX1000.Start();
        }

        void myNav_OnButtonChanged(object sender, HIDChangedEventArgs args)
        {

            CheckForIllegalCrossThreadCalls = false;

            textBox1.Text = args.HIDValue.Axe[0].State_Current.ToString();
            textBox2.Text = args.HIDValue.Axe[1].State_Current.ToString();
            textBox3.Text = args.HIDValue.Axe[2].State_Current.ToString();
            textBox4.Text = args.HIDValue.Axe[3].State_Current.ToString();
            textBox5.Text = args.HIDValue.Axe[4].State_Current.ToString();
            textBox6.Text = args.HIDValue.Axe[5].State_Current.ToString();

            textBox7.Text = args.HIDValue.Btn[0].State_Current.ToString();
            textBox8.Text = args.HIDValue.Btn[1].State_Current.ToString();

     /*       newJoy.SetAnalog(args.HIDValue.Axe[0].State_Current, 0);
            newJoy.SetAnalog(args.HIDValue.Axe[1].State_Current, 1);
            newJoy.SetAnalog(args.HIDValue.Axe[2].State_Current, 2);
            newJoy.SetAnalog(args.HIDValue.Axe[3].State_Current, 3);
            newJoy.SetAnalog(args.HIDValue.Axe[4].State_Current, 4);
            newJoy.SetAnalog(args.HIDValue.Axe[5].State_Current, 5);

            newJoy.SetDigital(args.HIDValue.Btn[0].State_Current, 0);
            newJoy.SetDigital(args.HIDValue.Btn[0].State_Current, 1);

            newJoy.SetDigital(args.HIDValue.Btn[1].State_Current, 8);
            newJoy.SetDigital(args.HIDValue.Btn[1].State_Current, 9);
        
            newJoy.SendData();
     
            myMouse.Mouse_SetScroll(-args.HIDValue.Axe[5].State_Current);
*/
           // myMouse.Mouse_SetMove(args.HIDValue.Axe[0].State_Current, args.HIDValue.Axe[1].State_Current);
      //      myMouse.Mouse_SetMove(-args.HIDValue.Axe[4].State_Current, args.HIDValue.Axe[3].State_Current);
  
            
            if (args.HIDValue.Btn[0].State_Changed)
            {
               if (args.HIDValue.Btn[0].State_Current)
                {
                    //Send_Keyb_Mouse.Key_Down(66);
                 //   myMouse.Mouse_Clic_Left(true);
                }
                else
                {
                 //   myMouse.Mouse_Clic_Left(false);
                   // Send_Keyb_Mouse.Key_Up(66);
                }
            }

            if (args.HIDValue.Btn[1].State_Changed)
            {

                if (args.HIDValue.Btn[1].State_Current)
                {
                    
               
                }
                else
                {
                    
                }
            }
            
            //throw new Exception("The method or operation is not implemented.");
        }



        void demar()
        {
            myNav = null;
            myNav = SpaceNavigator.FindSpaceNav();
            if (myNav != null)
            {
                myNav.OnButtonChanged += new HIDChangedEventHandler(myNav_OnButtonChanged);
            }
        }
     
        private void FormHID_FormClosing(object sender, FormClosingEventArgs e)
        {
     
        }

     
      
        [DllImport("USER32.DLL")]
        public static extern IntPtr GetForegroundWindow();
  
        [DllImport("user32.dll")]
       private static extern int GetWindowThreadProcessId(IntPtr hWnd,  ref int pptt);

        private void button3_Click(object sender, EventArgs e)
        {
           myNav.SetLights(0x00);

          
         /*  
            Process tmpProc; 
            int nThisProcessID = 0;
            while (true)
            {      
                GetWindowThreadProcessId(GetForegroundWindow(), ref nThisProcessID);
                tmpProc = Process.GetProcessById(nThisProcessID);
                Debug.WriteLine(tmpProc.MainModule.ModuleName);
                Thread.Sleep(1000);
            }
            */
        }

        [DllImport("user32.dll")]
        extern static uint MapVirtualKeyA(uint uCode, uint uMapType);


    }
}