using System;
using System.IO;
using System.Collections;
using System.Collections.Generic;
using System.Text;
using System.Runtime.InteropServices;
using Utilitaires;
using System.Diagnostics;
using Microsoft.Win32;



namespace RBC9___HID
{

    class BaseLst
    {
        private string _Txt;
        private object _Id;

        public BaseLst(string Txt, object Id)
        {
            this._Txt = Txt;
            this._Id = Id;

        }
        public string Txt
        {
            get { return _Txt; }
            set { _Txt = value; }
        }
        public object Id
        {
            get { return _Id; }
            set { _Id = value; }
        }

        public override string ToString()
        {
            return Txt;
        }
    }

    class MyConst
    {

        public const int NAV_MAX_VALUE = 360;
        public const byte KEY_BTN = 0x01;
        public const byte KEY_KEEP = 0x02;
        public const byte KEY_RELEASE = 0x04;
        public const byte KEY_REPEAT = 0x10;

        public const int LEN_COMMENT = 44;

        static public string BaseKey = "System\\ControlSet001\\Services\\RBC9SpaceNavigator\\Layout";

        static public ArrayList MyDevice_Txt = new ArrayList();

        static public ArrayList MyBindFrom_AxePart_Txt = new ArrayList();

        static public ArrayList MyBindFrom_FromType_Txt = new ArrayList();

        static public ArrayList MyBindTo_Txt = new ArrayList();

        static public ArrayList MyBindTo_JoyAxe_Txt = new ArrayList();
        static public ArrayList MyBindTo_JoyBtn_Txt = new ArrayList();
        static public ArrayList MyBindTo_JoyPov_Txt = new ArrayList();

        static public ArrayList MyBindTo_MouBtn_Txt = new ArrayList();

        static public ArrayList MyBindTo_Key_Txt = new ArrayList();
        static public ArrayList MyBindTo_KeyCode_Txt = new ArrayList();
        static public ArrayList MyBindTo_KeyWWW_Txt = new ArrayList();


        static public string MyTxt_ById(ArrayList MyArray, object Id)
        {
            foreach (BaseLst MyTxt in MyArray)
            {
                if (MyTxt.Id.Equals(Id))
                {
                    return MyTxt.Txt;
                }
            }
            return null;
        }

        static MyConst()
        {
            ModifyRegistry myRegistry = new ModifyRegistry();
            myRegistry.BaseRegistryKey = Registry.LocalMachine;
            myRegistry.SubKey = "System\\Select";
            BaseKey = "System\\ControlSet" + myRegistry.ReadInt32("Current").ToString("000") + "\\Services\\RBC9SpaceNavigator\\Layout";


            MyDevice_Txt.Add(new BaseLst("SpaceNavigator", (int) 0xC626));
            MyDevice_Txt.Add(new BaseLst("SpacePilot", (int) 0xC625));
            MyDevice_Txt.Add(new BaseLst("SpaceTraveler", (int)0xC623));
            MyDevice_Txt.Add(new BaseLst("SpaceBall", (int)0xC621));

            MyBindTo_Txt.Add(new BaseLst("New Bind", BIND_TO.BIND_TO_NOBIND));
            MyBindTo_Txt.Add(new BaseLst("Joy Axe", BIND_TO.BIND_TO_JOYSTICK_AXE));
            MyBindTo_Txt.Add(new BaseLst("Joy Btn", BIND_TO.BIND_TO_JOYSTICK_BTN));
            MyBindTo_Txt.Add(new BaseLst("Joy POV", BIND_TO.BIND_TO_JOYSTICK_POV));
            MyBindTo_Txt.Add(new BaseLst("Mouse X", BIND_TO.BIND_TO_MOUSE_X));
            MyBindTo_Txt.Add(new BaseLst("Mouse Y", BIND_TO.BIND_TO_MOUSE_Y));
            MyBindTo_Txt.Add(new BaseLst("Mouse Wheel", BIND_TO.BIND_TO_MOUSE_WHEEL));
            MyBindTo_Txt.Add(new BaseLst("Mouse Btn", BIND_TO.BIND_TO_MOUSE_BTN));
            MyBindTo_Txt.Add(new BaseLst("Keyboard", BIND_TO.BIND_TO_KEYB));
            MyBindTo_Txt.Add(new BaseLst("Special Key", BIND_TO.BIND_TO_WWW));
            MyBindTo_Txt.Add(new BaseLst("Switch Layout", BIND_TO.BIND_TO_PROFIL));
            // MyBindTo_Txt.Add(new BaseLst("BIND_TO_TEST", BIND_TO.BIND_TO_TEST));


            MyBindTo_JoyAxe_Txt.Add(new BaseLst("X", (byte)0));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("Y", (byte)1));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("Z", (byte)2));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("rX", (byte)3));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("rY", (byte)4));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("rZ", (byte)5));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("Slider", (byte)6));
            MyBindTo_JoyAxe_Txt.Add(new BaseLst("Slider2", (byte)7));
          //  MyBindTo_JoyAxe_Txt.Add(new BaseLst("Throttle", (byte)8));


            MyBindFrom_AxePart_Txt.Add(new BaseLst("Full Axe", SEMI_AXE.AXE_ALL));
            MyBindFrom_AxePart_Txt.Add(new BaseLst("Semi Axe  > 0", SEMI_AXE.AXE_POS));
            MyBindFrom_AxePart_Txt.Add(new BaseLst("Semi Axe  < 0", SEMI_AXE.AXE_NEG));

            MyBindFrom_FromType_Txt.Add(new BaseLst("Standart", PRESS_TYPE.PRESS_STD));
            MyBindFrom_FromType_Txt.Add(new BaseLst("Short Press", PRESS_TYPE.PRESS_SHORT));
            MyBindFrom_FromType_Txt.Add(new BaseLst("Long Press", PRESS_TYPE.PRESS_LONG));


            MyBindTo_JoyPov_Txt.Add(new BaseLst("Up / Down", BIND_POV.POV_VERT));
            MyBindTo_JoyPov_Txt.Add(new BaseLst("Left / Right", BIND_POV.POV_HORI));


            MyBindTo_JoyBtn_Txt.Add(new BaseLst("1", (byte)0));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("2", (byte)1));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("3", (byte)2));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("4", (byte)3));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("5", (byte)4));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("6", (byte)5));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("7", (byte)6));
            MyBindTo_JoyBtn_Txt.Add(new BaseLst("8", (byte)7));

            MyBindTo_MouBtn_Txt.Add(new BaseLst("Left", (byte)0));
            MyBindTo_MouBtn_Txt.Add(new BaseLst("Right", (byte)1));
            MyBindTo_MouBtn_Txt.Add(new BaseLst("Middle", (byte)2));
            MyBindTo_MouBtn_Txt.Add(new BaseLst("Mouse 4", (byte)3));
            MyBindTo_MouBtn_Txt.Add(new BaseLst("Mouse 5", (byte)4));


            MyBindTo_Key_Txt.Add(new BaseLst("Key Press", (byte)KEY_BTN));
            MyBindTo_Key_Txt.Add(new BaseLst("Key Hold", (byte)KEY_KEEP));
            MyBindTo_Key_Txt.Add(new BaseLst("Key Release", (byte)KEY_RELEASE));

            {
                MyBindTo_KeyCode_Txt.Add(new BaseLst("", (byte)0x00));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("a / A", (byte)0x04));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("b / B", (byte)0x05));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("c / C", (byte)0x06));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("d / D", (byte)0x07));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("e / E", (byte)0x08));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("f / F", (byte)0x09));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("g / G", (byte)0x0a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("h / H", (byte)0x0b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("i / I", (byte)0x0c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("j / J", (byte)0x0d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("k / K", (byte)0x0e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("l / L", (byte)0x0f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("m / M", (byte)0x10));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("n / N", (byte)0x11));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("o / O", (byte)0x12));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("p / P", (byte)0x13));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("q / Q", (byte)0x14));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("r / R", (byte)0x15));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("s / S", (byte)0x16));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("t / T", (byte)0x17));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("u / U", (byte)0x18));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("v / V", (byte)0x19));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("w / W", (byte)0x1a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("x / X", (byte)0x1b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("y / Y", (byte)0x1c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("z / Z", (byte)0x1d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("1", (byte)0x1e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("2", (byte)0x1f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("3", (byte)0x20));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("4", (byte)0x21));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("5", (byte)0x22));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("6", (byte)0x23));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("7", (byte)0x24));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("8", (byte)0x25));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("9", (byte)0x26));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("0", (byte)0x27));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Enter", (byte)0x28));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Esc", (byte)0x29));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Back Space", (byte)0x2a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Tab", (byte)0x2b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Space", (byte)0x2c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("- / _", (byte)0x2d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("= / +", (byte)0x2e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("[ / {", (byte)0x2f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("] / }", (byte)0x30));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("\\ / |", (byte)0x31));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Non-US # / ~", (byte)0x32));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("; / :", (byte)0x33));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("\x91 / \x93", (byte)0x34));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Grave Accent / Tilde", (byte)0x35));
                MyBindTo_KeyCode_Txt.Add(new BaseLst(", / <", (byte)0x36));
                MyBindTo_KeyCode_Txt.Add(new BaseLst(". / >", (byte)0x37));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("/ / ?", (byte)0x38));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Caps Lock", (byte)0x39));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F1", (byte)0x3a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F2", (byte)0x3b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F3", (byte)0x3c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F4", (byte)0x3d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F5", (byte)0x3e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F6", (byte)0x3f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("F7", (byte)0x40));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F8", (byte)0x41));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F9", (byte)0x42));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F10", (byte)0x43));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F11", (byte)0x44));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("F12", (byte)0x45));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Print Screen", (byte)0x46));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Scroll Lock", (byte)0x47));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Pause", (byte)0x48));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Insert", (byte)0x49));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Home", (byte)0x4a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Page Up", (byte)0x4b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Delete", (byte)0x4c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("End", (byte)0x4d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Page Down", (byte)0x4e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Right Arrow", (byte)0x4f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("Left Arrow", (byte)0x50));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Down Arrow", (byte)0x51));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Up Arrow", (byte)0x52));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad Num Lock / Clear", (byte)0x53));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad /", (byte)0x54));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad *", (byte)0x55));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad -", (byte)0x56));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad +", (byte)0x57));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad Enter", (byte)0x58));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 1 / End", (byte)0x59));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 2 / Down Arrow", (byte)0x5a));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 3 / Page Down", (byte)0x5b));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 4 / Left Arrow", (byte)0x5c));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 5", (byte)0x5d));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 6 / Right Arrow", (byte)0x5e));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 7 / Home", (byte)0x5f));

                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 8 / Up Arrow", (byte)0x60));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 9 / Page Up", (byte)0x61));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad 0 / Insert", (byte)0x62));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Keypad . / Delete", (byte)0x63));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Non-US \\ / |", (byte)0x64));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Application", (byte)0x65));
             

                MyBindTo_KeyCode_Txt.Add(new BaseLst("Left Control", (byte)0xe0));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Left Shift", (byte)0xe1));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Left Alt", (byte)0xe2));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Left GUI", (byte)0xe3));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Right Control", (byte)0xe4));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Right Shift", (byte)0xe5));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Right Alt", (byte)0xe6));
                MyBindTo_KeyCode_Txt.Add(new BaseLst("Right GUI", (byte)0xe7));

            }

            {

                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Mute", (byte)0x01));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Volume Up", (byte)0x02));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Volume Down", (byte)0x03));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Play/Pause", (byte)0x04));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Stop", (byte)0x05));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Previous Track", (byte)0x06));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Next Track", (byte)0x07));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Calculator", (byte)0x09));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("Mail", (byte)0x08));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www search", (byte)0x0A));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www home", (byte)0x0B));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www favorites", (byte)0x0C));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www refresh", (byte)0x0D));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www stop", (byte)0x0E));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www forward", (byte)0x0F));
                MyBindTo_KeyWWW_Txt.Add(new BaseLst("www back", (byte)0x10));

            }

        }

    }

    public enum BIND_FROM
    {
        BIND_FROM_AXE,
        BIND_FROM_BTN,
    } ;

    public enum SEMI_AXE
    {
        AXE_ALL = 0,
        AXE_POS,
        AXE_NEG,
    };

    public enum PRESS_TYPE
    {
        PRESS_STD=0,
	    PRESS_SHORT,
	    PRESS_LONG,
    };

 
    public enum BIND_TO
    {
        BIND_TO_NOBIND = 0,
        BIND_TO_JOYSTICK_AXE,
        BIND_TO_JOYSTICK_BTN,
        BIND_TO_JOYSTICK_POV,
        BIND_TO_MOUSE_X,
        BIND_TO_MOUSE_Y,
        BIND_TO_MOUSE_WHEEL,
        BIND_TO_MOUSE_BTN,
        BIND_TO_KEYB,
        BIND_TO_PROFIL,
        BIND_TO_WWW,

    } ;


    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct NAVAXE
    {
        public byte NumAxe;
        public byte Invert;
        public short DeadZone;
        public short MinVal;
        public short MaxVal;
        public SEMI_AXE AxePart;
    };

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct NAVBTN
    {
        public byte NumBtn;
        public byte Invert;
        public short FalseVal;
        public short TrueVal;
    } ;

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct FROMTYPE
    {
        public short Delay;
        public PRESS_TYPE Type;
    } ;

    public enum BIND_POV
    {
        POV_VERT,
        POV_HORI,

    } ;

    [StructLayout(LayoutKind.Explicit, Pack = 1)]
    public struct JOY_BIND
    {
        [FieldOffset(0)]
        public byte Axe;
        [FieldOffset(0)]
        public byte Btn;
        [FieldOffset(0)]
        public BIND_POV POV;
    } ;

    [StructLayout(LayoutKind.Explicit, Pack = 1)]
    public struct MOU_BIND
    {
        [FieldOffset(0)]
        public byte Sensi;
        [FieldOffset(0)]
        public byte Wheel_Speed;
        [FieldOffset(0)]
        public byte Btn;
    } ;

    [StructLayout(LayoutKind.Sequential, Pack = 1)]
    public struct KEY_BIND
    {
        public byte Event;
        public short FireDelay;

        public byte Code1;
        public byte Code2;
        public byte Code3;
        public byte Code4;
        public byte Code5;


    } ;


    [StructLayout(LayoutKind.Explicit, Pack = 1)]
    public unsafe struct BIND_STRUCT
    {

        [FieldOffset(0)]
        public BIND_FROM BindFrom;

        [FieldOffset(4)]
        public NAVAXE FromAxe;
        [FieldOffset(4)]
        public NAVBTN FromBtn;

        [FieldOffset(16)]
        public BIND_TO BindTo;

        [FieldOffset(20)]
        public JOY_BIND Joy;
        [FieldOffset(20)]
        public MOU_BIND Mou;
        [FieldOffset(20)]
        public KEY_BIND Key;
        [FieldOffset(20)]
        public short Profil_Id;
        [FieldOffset(20)]
        public byte www;

        [FieldOffset(28)]
        public FROMTYPE FromType;

        [FieldOffset(40)]
        [MarshalAs(UnmanagedType.ByValArray, SizeConst = MyConst.LEN_COMMENT)]
        public char[] Comment;

    };

    class LayoutBind
    {
        private BIND_STRUCT BindToDo = new BIND_STRUCT();

        public LayoutBind(BIND_FROM BindFrom, byte BindFromNum, BIND_TO BindTo)
        {
            this.BindFrom = BindFrom;
            this.BindFromNum = BindFromNum;
            this.BindTo = BindTo;
            this.Comment = "";
        }
        public LayoutBind(BIND_FROM BindFrom, byte BindFromNum)
        {
            this.BindFrom = BindFrom;
            this.BindFromNum = BindFromNum;
            this.BindTo = BIND_TO.BIND_TO_NOBIND;
            this.Comment = "";
        }

        public LayoutBind(byte[] ByteStruct)
        {
            

            BindByte = ByteStruct;
        }

        public byte[] BindByte
        {
            get
            {

                byte[] buffer = new byte[Marshal.SizeOf(BindToDo)];

                GCHandle h = GCHandle.Alloc(buffer, GCHandleType.Pinned);

                Marshal.StructureToPtr(BindToDo, h.AddrOfPinnedObject(), false);

                h.Free();
                
                return buffer;
            }

            set
            {
                GCHandle h = GCHandle.Alloc(value, GCHandleType.Pinned);

                BindToDo = (BIND_STRUCT)Marshal.PtrToStructure(h.AddrOfPinnedObject(), typeof(BIND_STRUCT));

                h.Free();
                if (value.Length < Marshal.SizeOf(typeof(BIND_STRUCT)))
                {
                    this.Comment = "";
                }

            }
        }

        public String Comment
        {
           get
            {
                GCHandle h = GCHandle.Alloc(BindToDo.Comment, GCHandleType.Pinned);

              
                string Retour = (string)Marshal.PtrToStringUni(h.AddrOfPinnedObject());

                h.Free();

                return Retour;
            }

            set
            {
                if (BindToDo.Comment == null)
                {
                    BindToDo.Comment = new char[MyConst.LEN_COMMENT];
                }

                for (int i = 0; i < BindToDo.Comment.Length; BindToDo.Comment[i++] = '\0') ;
                    
                value.ToCharArray(0, value.Length < MyConst.LEN_COMMENT ? value.Length : MyConst.LEN_COMMENT).CopyTo(BindToDo.Comment, 0);

                
            }
        }

        public BIND_FROM BindFrom
        {
            get { return BindToDo.BindFrom; }
            set
            {

                BindToDo.BindFrom = value;
               
                FromType = PRESS_TYPE.PRESS_STD;
 
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        BindToDo.FromAxe.NumAxe = 0;
                        BindToDo.FromAxe.Invert = 0;
                        BindToDo.FromAxe.DeadZone = 0;
                        BindToDo.FromAxe.MinVal = 0;
                        BindToDo.FromAxe.MaxVal = MyConst.NAV_MAX_VALUE;
                        BindToDo.FromAxe.AxePart = SEMI_AXE.AXE_ALL;
                        break;

                    case BIND_FROM.BIND_FROM_BTN:
                        BindToDo.FromBtn.NumBtn = 0;
                        BindToDo.FromBtn.Invert = 0;
                        BindToDo.FromBtn.FalseVal = 0;
                        BindToDo.FromBtn.TrueVal = MyConst.NAV_MAX_VALUE;
                        break;
                }
            }
        }

        public byte BindFromNum
        {
            get
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        return BindToDo.FromAxe.NumAxe;


                    case BIND_FROM.BIND_FROM_BTN:
                        return BindToDo.FromBtn.NumBtn;
                }
                return 0;
            }


            set
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        BindToDo.FromAxe.NumAxe = value;
                        break;

                    case BIND_FROM.BIND_FROM_BTN:
                        BindToDo.FromBtn.NumBtn = value;
                        break;
                }

            }

        }
        public byte Invert
        {
            get
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        return BindToDo.FromAxe.Invert;


                    case BIND_FROM.BIND_FROM_BTN:
                        return BindToDo.FromBtn.Invert;
                }
                return 0;
            }


            set
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        BindToDo.FromAxe.Invert = value;
                        break;

                    case BIND_FROM.BIND_FROM_BTN:
                        BindToDo.FromBtn.Invert = value;
                        break;
                }

            }
        }

        public short DeadZone
        {
            get
            {
                if (BindToDo.BindFrom == BIND_FROM.BIND_FROM_AXE)
                {
                    return BindToDo.FromAxe.DeadZone;
                }


                return 0;
            }


            set
            {
                short NewVal = value;
                if (NewVal > MyConst.NAV_MAX_VALUE)
                    NewVal = MyConst.NAV_MAX_VALUE;

                if (BindToDo.BindFrom == BIND_FROM.BIND_FROM_AXE)
                    BindToDo.FromAxe.DeadZone = NewVal;
            }
        }

        public short FromDelay
        {
            get
            {

                return BindToDo.FromType.Delay;

            }

            set
            {

                BindToDo.FromType.Delay = value;
            }
        }

        public short MinVal
        {
            get
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        return BindToDo.FromAxe.MinVal;


                    case BIND_FROM.BIND_FROM_BTN:
                        return BindToDo.FromBtn.FalseVal;
                }
                return 0;
            }


            set
            {
                short NewVal = value;
                if (NewVal < 0)
                    NewVal = 0;
                if (NewVal > MyConst.NAV_MAX_VALUE)
                    NewVal = MyConst.NAV_MAX_VALUE;


                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        BindToDo.FromAxe.MinVal = NewVal;
                        break;

                    case BIND_FROM.BIND_FROM_BTN:
                        BindToDo.FromBtn.FalseVal = NewVal;
                        break;
                }

            }
        }
        public short MaxVal
        {
            get
            {
                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        return BindToDo.FromAxe.MaxVal;


                    case BIND_FROM.BIND_FROM_BTN:
                        return BindToDo.FromBtn.TrueVal;
                }
                return 0;
            }


            set
            {
                short NewVal = value;
                if (NewVal < 0)
                    NewVal = 0;
                if (NewVal > MyConst.NAV_MAX_VALUE)
                    NewVal = MyConst.NAV_MAX_VALUE;

                switch (BindToDo.BindFrom)
                {
                    case BIND_FROM.BIND_FROM_AXE:
                        BindToDo.FromAxe.MaxVal = NewVal;
                        break;

                    case BIND_FROM.BIND_FROM_BTN:
                        BindToDo.FromBtn.TrueVal = NewVal;
                        break;
                }

            }
        }
        public SEMI_AXE AxePart
        {
            get { return BindToDo.FromAxe.AxePart; }
            set { BindToDo.FromAxe.AxePart = value; }
        }

        public PRESS_TYPE FromType
        {
            get { return BindToDo.FromType.Type; }
            set {

                BindToDo.FromType.Type = value;
                if (BindToDo.FromType.Type == PRESS_TYPE.PRESS_STD)
                {
                    BindToDo.FromType.Delay = 0;
                }
                else
                {
                    BindToDo.FromType.Delay = 500;
                }
            
            }
        }

        public BIND_TO BindTo
        {
            get { return BindToDo.BindTo; }
            set
            {

                BindToDo.BindTo = value;

                switch (BindToDo.BindTo)
                {
                    case BIND_TO.BIND_TO_JOYSTICK_AXE:
                        BindToDo.Joy.Axe = 0;
                        break;
                    case BIND_TO.BIND_TO_JOYSTICK_BTN:
                        BindToDo.Joy.Btn = 0;
                        break;
                    case BIND_TO.BIND_TO_JOYSTICK_POV:
                        BindToDo.Joy.POV = BIND_POV.POV_VERT;
                        break;

                    case BIND_TO.BIND_TO_MOUSE_BTN:
                        BindToDo.Mou.Btn = 0;
                        break;

                    case BIND_TO.BIND_TO_MOUSE_X:
                        BindToDo.Mou.Sensi = 100;
                        break;

                    case BIND_TO.BIND_TO_MOUSE_Y:
                        BindToDo.Mou.Sensi = 100;
                        break;

                    case BIND_TO.BIND_TO_MOUSE_WHEEL:
                        BindToDo.Mou.Wheel_Speed = 100;
                        break;

                    case BIND_TO.BIND_TO_PROFIL:
                        BindToDo.Profil_Id = -1;
                        break;

                    case BIND_TO.BIND_TO_KEYB:
                        BindToDo.Key.Event = MyConst.KEY_BTN;
                        BindToDo.Key.FireDelay = 10;
                        BindToDo.Key.Code1 = 0;
                        BindToDo.Key.Code2 = 0;
                        BindToDo.Key.Code3 = 0;
                        BindToDo.Key.Code4 = 0;
                        BindToDo.Key.Code5 = 0;
                        break;

                    case BIND_TO.BIND_TO_WWW:
                        BindToDo.www = 0;
                        break;

                }
            }
        }

        public string BindTo_Txt
        {
            get
            {
                string TmpTxt = MyConst.MyTxt_ById(MyConst.MyBindTo_Txt, BindToDo.BindTo);

                switch (BindToDo.BindTo)
                {
                    case BIND_TO.BIND_TO_JOYSTICK_AXE:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_JoyAxe_Txt, BindToDo.Joy.Axe);

                        break;
                    case BIND_TO.BIND_TO_JOYSTICK_BTN:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_JoyBtn_Txt, BindToDo.Joy.Btn);
                        break;
                    case BIND_TO.BIND_TO_JOYSTICK_POV:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_JoyPov_Txt, BindToDo.Joy.POV);
                        break;

                    case BIND_TO.BIND_TO_MOUSE_BTN:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_MouBtn_Txt, BindToDo.Mou.Btn);
                        break;

                    case BIND_TO.BIND_TO_KEYB:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_KeyCode_Txt, BindToDo.Key.Code1);
                        break;

                    case BIND_TO.BIND_TO_WWW:
                        TmpTxt = TmpTxt + " : " + MyConst.MyTxt_ById(MyConst.MyBindTo_KeyWWW_Txt, BindToDo.www);
                        break;

                }

                return TmpTxt;
            }
        }
        public byte BindTo_JoyAxe
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_JOYSTICK_AXE)
                {
                    return 0;
                }


                return BindToDo.Joy.Axe;

            }
            set { BindToDo.Joy.Axe = value; }
        }
        public byte BindTo_JoyBtn
        {
            get
            {

                if (BindToDo.BindTo != BIND_TO.BIND_TO_JOYSTICK_BTN)
                {
                    return 0;
                }


                return BindToDo.Joy.Btn;


            }
            set { BindToDo.Joy.Btn = value; }
        }

        public byte BindTo_MouBtn
        {
            get
            {

                if (BindToDo.BindTo != BIND_TO.BIND_TO_MOUSE_BTN)
                {
                    return 0;
                }


                return BindToDo.Mou.Btn;

            }
            set { BindToDo.Mou.Btn = value; }
        }

        public byte BindTo_MouSensi
        {
            get
            {

                if ((BindToDo.BindTo != BIND_TO.BIND_TO_MOUSE_X)
                    && (BindToDo.BindTo != BIND_TO.BIND_TO_MOUSE_Y)
                    && (BindToDo.BindTo != BIND_TO.BIND_TO_MOUSE_WHEEL))
                {
                    return 0;
                }


                return BindToDo.Mou.Sensi;

            }
            set { BindToDo.Mou.Sensi = value; }
        }

        public BIND_POV BindTo_JoyPov
        {
            get
            {

                if (BindToDo.BindTo != BIND_TO.BIND_TO_JOYSTICK_POV)
                {
                    return BIND_POV.POV_VERT;
                }


                return BindToDo.Joy.POV;

            }
            set { BindToDo.Joy.POV = value; }
        }

        public short BindTo_ProfilId
        {
            get
            {

                if (BindToDo.BindTo != BIND_TO.BIND_TO_PROFIL)
                {
                    return 0;
                }


                return BindToDo.Profil_Id;


            }
            set { BindToDo.Profil_Id = value; }
        }


        public byte BindTo_Key
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return MyConst.KEY_BTN;
                }


                return (byte)(BindToDo.Key.Event & 0x0f);
            }
            set
            {
                BindToDo.Key.Event &= 0xf0;

                BindToDo.Key.Event |= value;

            }
        }

        public bool BindTo_KeyRepeat
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return false;
                }


                return (bool)((BindToDo.Key.Event & MyConst.KEY_REPEAT) == MyConst.KEY_REPEAT);
            }
            set
            {
                if (value)
                {
                    BindToDo.Key.Event |= MyConst.KEY_REPEAT;
                }
                else
                {

                    BindToDo.Key.Event &= 0x0f;
                }
            }
        }

        public short BindTo_KeyDelay
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }


                return BindToDo.Key.FireDelay;
            }
            set
            {
                BindToDo.Key.FireDelay = value;
            }
        }

        public byte BindTo_Key1
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }
                return BindToDo.Key.Code1;
            }
            set { BindToDo.Key.Code1 = value; }
        }

        public byte BindTo_Key2
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }
                return BindToDo.Key.Code2;
            }
            set { BindToDo.Key.Code2 = value; }
        }

        public byte BindTo_Key3
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }
                return BindToDo.Key.Code3;
            }
            set { BindToDo.Key.Code3 = value; }
        }

        public byte BindTo_Key4
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }
                return BindToDo.Key.Code4;
            }
            set { BindToDo.Key.Code4 = value; }
        }

        public byte BindTo_Key5
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_KEYB)
                {
                    return 0;
                }
                return BindToDo.Key.Code5;
            }
            set { BindToDo.Key.Code5 = value; }
        }


        public byte BindTo_WWW
        {
            get
            {
                if (BindToDo.BindTo != BIND_TO.BIND_TO_WWW)
                {
                    return 0;
                }
                return BindToDo.www;
            }
            set { BindToDo.www = value; }
        }
    }


    class LayoutStruct : IComparable 
    {

        private string _Profil_Name;
        private string _RegKey;
        private short _Profil_Id;
        private int _DeadZone;

        public ArrayList _Bind = new ArrayList();
        public ArrayList _AppAuto = new ArrayList();

        public LayoutStruct(string RegKey)
        {
            ReadLayout(RegKey, true);
        }

        public LayoutStruct(string RegKey, bool LoadBind)
        {
            ReadLayout(RegKey, LoadBind);
        }

        public LayoutStruct(short Profil_Id)
        {
            this.Profil_Name = "- New Layout -";
            this.DeadZone = 0;
            this.Profil_Id = Profil_Id;

        }

        public int CompareTo(object obj)
        {
            if (obj is LayoutStruct)
            {
                LayoutStruct temp = (LayoutStruct)obj;

                return _Profil_Name.CompareTo(temp._Profil_Name);
            }

            throw new ArgumentException("object is not a LayoutStruct");
        }


        private void ReadLayout(string RegKey, bool LoadBind)
        {
            string[] MyAppAutoLst;

            ModifyRegistry myRegistry = new ModifyRegistry();
            myRegistry.BaseRegistryKey = Registry.LocalMachine;
            myRegistry.SubKey = MyConst.BaseKey + "\\" + RegKey;

            this._RegKey = RegKey;

            this.Profil_Name = myRegistry.ReadString("Profil_Name");
            this.DeadZone = myRegistry.ReadInt32("DeadZone");
            this.Profil_Id = (short)myRegistry.ReadInt32("Profil_Id");
            MyAppAutoLst = (string[])myRegistry.Read("AppAuto");

            _AppAuto.Clear();
            if (MyAppAutoLst != null)
            {
                foreach (string MyAppAuto in MyAppAutoLst)
                {
                    _AppAuto.Add(new BaseLst(MyAppAuto, this.Profil_Id));
                }
            }

            if (LoadBind)
                ReadBind();
        }

        private void ReadBind()
        {

            ModifyRegistry myRegistry = new ModifyRegistry();

            myRegistry.BaseRegistryKey = Registry.LocalMachine;
            myRegistry.SubKey = MyConst.BaseKey + "\\" + _RegKey;

            _Bind.Clear();

            foreach (string BindName in myRegistry.ValueNames())
            {
                if (BindName.IndexOf("Bind - ") == 0)
                {
                    _Bind.Add(new LayoutBind(myRegistry.ReadBinary(BindName)));
                }
            }


        }

        public void ExportBind(string FileName)
        {
            int TailleBind = Marshal.SizeOf(typeof(BIND_STRUCT));
            byte[] buffer = new byte[_Bind.Count * TailleBind];
            int NumBind = 0;
         
            foreach (LayoutBind Bind in _Bind)
            {
                Array.Copy(Bind.BindByte, 0, buffer, NumBind * TailleBind, TailleBind);
                NumBind++;
            }
            File.WriteAllBytes(FileName, buffer);
        }


        public void ImportBind(string FileName)
        {
            int TailleBind = Marshal.SizeOf(typeof(BIND_STRUCT));
            byte[] buffer;
            int NumBind = 0;

            buffer = File.ReadAllBytes(FileName);
            if ((buffer.Length % TailleBind) != 0)
            {
                TailleBind = 34; // struct end  from type
                if ((buffer.Length % TailleBind) != 0)
                {
                    TailleBind = 30; // struct end www
                }
            }

            byte[] NewBind = new byte[TailleBind]; 

            if (buffer.Length <= 0) return;

            for (NumBind = 0; NumBind < buffer.Length / TailleBind; NumBind++)
            {
                 Array.Copy(buffer, NumBind * TailleBind, NewBind, 0, TailleBind);
                 _Bind.Add(new LayoutBind(NewBind));
            }
        }
        
        public void Save()
        {
            string[] MyAppAutoLst;
            int BclStr;
            int NumBind;

            ModifyRegistry myRegistry = new ModifyRegistry();
            myRegistry.BaseRegistryKey = Registry.LocalMachine;
            
            _RegKey = "Layout - " + Profil_Id.ToString("[0000]");

            myRegistry.SubKey = MyConst.BaseKey + "\\" + _RegKey;

            myRegistry.Write("Profil_Id", (Int32)_Profil_Id);
            myRegistry.Write("Profil_Name", _Profil_Name);
            myRegistry.Write("DeadZone", (Int32)_DeadZone);

            NumBind = 0;
            foreach (LayoutBind Bind in _Bind)
            {
                myRegistry.Write("Bind - " + NumBind.ToString("[0000]"), Bind.BindByte);
                NumBind++;
            }

            MyAppAutoLst = new string[_AppAuto.Count];
            BclStr = 0;
            foreach (BaseLst MyAppAuto in _AppAuto)
            {
                MyAppAutoLst[BclStr++] = MyAppAuto.Txt;
            }
            myRegistry.Write("AppAuto", MyAppAutoLst);
        }

        public string Profil_Name
        {
            get { return _Profil_Name; }
            set { _Profil_Name = value; }
        }

        public string RegKey
        {
            get { return _RegKey; }
            set { _RegKey = value; }
        }

        public short Profil_Id
        {
            get { return _Profil_Id; }
            set { _Profil_Id = value; }
        }

        public int DeadZone
        {
            get { return _DeadZone; }
            set
            {

                _DeadZone = value;

                if (_DeadZone < 0)
                    _DeadZone = 0;

                if (_DeadZone > MyConst.NAV_MAX_VALUE)
                    _DeadZone = MyConst.NAV_MAX_VALUE;


            }
        }

        public override string ToString()
        {
            return string.Format("[{0}] {1}", Profil_Id.ToString("0000"), _Profil_Name);
        }
    }

    class LayoutList
    {
        private short _Default_Profil;
        private short _Last_Profil;
        private bool _AutoSwitch;
        private bool _InfoBulle;
        private bool _StopIcon;
        private int _DeviceId;
        private bool _LEDEnable;

        public ArrayList _Layout = new ArrayList();
        ModifyRegistry myRegistry = new ModifyRegistry();

        public LayoutList()
        {
            myRegistry.BaseRegistryKey = Registry.LocalMachine;
            myRegistry.SubKey = MyConst.BaseKey;

        }

        private short NexId()
        {
            short NewId = 1;
            foreach (LayoutStruct Layout in _Layout)
            {
                if (Layout.Profil_Id >= NewId)
                {
                    NewId = (short)(Layout.Profil_Id + 1);
                }
            }
            return NewId;
        }

        public int AddNewLayout()
        {

            return _Layout.Add(new LayoutStruct(NexId()));
            
        }

        public int Duplicate(LayoutStruct Source)
        {
            LayoutStruct NewLayout = new LayoutStruct(NexId());
            NewLayout.Profil_Name = "Copy of <- " + Source.Profil_Name + " ->";
            NewLayout.DeadZone = Source.DeadZone;

            foreach (LayoutBind SourceBind in Source._Bind)
            {
                NewLayout._Bind.Add(SourceBind);
            }

            /*   foreach(BaseLst SourceApp in Source._AppAuto)
               {
                  NewLayout._AppAuto.Add(new BaseLst(SourceApp.Txt, NewLayout.Profil_Id));
               }*/
            return _Layout.Add(NewLayout);

        }

        public short Default_Profil
        {
            get { return _Default_Profil; }
            set { _Default_Profil = value; }
        }

        public short Last_Profil
        {
            get { return _Last_Profil; }
            set { _Last_Profil = value; }
        }

        public bool AutoSwitch
        {
            get { return _AutoSwitch; }
            set { _AutoSwitch = value; }
        }

        public bool InfoBulle
        {
            get { return _InfoBulle; }
            set { _InfoBulle = value; }
        }

        public bool LEDEnable
        {
            get { return _LEDEnable; }
            set { _LEDEnable = value; }
        }

        public bool StopIcon
        {
            get { return _StopIcon; }
            set { _StopIcon = value; }
        }

        public int DeviceId
        {
            get { return _DeviceId; }
            set { _DeviceId = value; }
        }

        public void LoadLayout()
        {

            LoadLayout(true);

        }

        public void LoadLayout(bool LoadBind)
        {

            string[] LayoutList;
            _Layout.Clear();

            Default_Profil = (short)myRegistry.ReadInt32("Default_Profil");
            if (Default_Profil == 0)
                Default_Profil = -1;

            Last_Profil = (short)myRegistry.ReadInt32("Last_Profil");
            if (Last_Profil == 0)
                Last_Profil = -1;

            AutoSwitch = (myRegistry.ReadInt32("AutoSwitch") != 0) ? true : false;

            InfoBulle = (myRegistry.ReadInt32("InfoBulle") != 0) ? true : false;

            StopIcon = (myRegistry.ReadInt32("StopIcon") != 0) ? true : false;

            LEDEnable = (myRegistry.ReadInt32("LEDOff") == 0) ? true : false;

            DeviceId = myRegistry.ReadInt32("DeviceId");
            if (DeviceId == 0)
                DeviceId = 0xC626;

            LayoutList = myRegistry.SubKeyNames();
            if (LayoutList != null)
            {
                foreach (string LayoutName in LayoutList)
                {
                    if (LayoutName.IndexOf("Layout - ") == 0)
                    {
                        _Layout.Add(new LayoutStruct(LayoutName, LoadBind));
                    }
                }
            }

            if ((_Layout.Count == 0) && (LoadBind))
            {
                AddNewLayout();
            }
            _Layout.Sort();

        }

        public void Save()
        {
            //Debug.WriteLine("here");
            myRegistry.DeleteSubKeyTree();
            myRegistry.Write("Default_Profil", (Int32)Default_Profil);
            myRegistry.Write("Last_Profil", (Int32)Last_Profil);
            myRegistry.Write("AutoSwitch", AutoSwitch ? 1 : 0);
            myRegistry.Write("InfoBulle", InfoBulle ? 1 : 0);
            myRegistry.Write("StopIcon", StopIcon ? 1 : 0);
            myRegistry.Write("LEDOff", LEDEnable ? 0 : 1);
            myRegistry.Write("DeviceId", DeviceId );
            foreach (LayoutStruct Layout in _Layout)
            {
                Layout.Save();
            }


        }

    }
}
