using System;
using System.Collections.Generic;
using System.ComponentModel;
//using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using Microsoft.Win32;
using Utilitaires;
using USB_HID;
using System.Runtime.InteropServices;
using System.Diagnostics;
using System.Threading;
using System.Collections;

using System.IO;

namespace RBC9___HID
{

     public partial class RBC9SpaceNav : Form
    {
         LayoutList MyLayout = new LayoutList();
         ArrayList MyBindFiltre = new ArrayList();
         SpaceNavigator myNav;
         SpaceNavigator MainNav;

         LayoutBind ClipBoardBind;
         BIND_FROM BindFrom=BIND_FROM.BIND_FROM_AXE;
         byte BindFromNum = 0;



         public RBC9SpaceNav(ref SpaceNavigator MainSpaceNav)
         {
             InitializeComponent();
             MainNav = MainSpaceNav;
         }

        private void RBC9_Load(object sender, EventArgs e)
        {
            int Last_Edited_Profil = 0;
 
            Init_CboKey();

            MyLayout.LoadLayout();

            Last_Edited_Profil = MyLayout.Last_Profil;

            layoutStructBindingSource.DataSource = MyLayout._Layout;
            
            layoutAppAutoBindingSource.DataSource = ((LayoutStruct)layoutStructBindingSource.Current)._AppAuto;
            ProfilLstBindingSource.DataSource = MyLayout._Layout;
            DefaultLayoutBindingSource.DataSource = MyLayout._Layout;
            cboDefault.SelectedValue = MyLayout.Default_Profil;

            chkAutoApp.Checked = MyLayout.AutoSwitch;
            chkInfoBulle.Checked = MyLayout.InfoBulle;
            chkLEDEnable.Checked = MyLayout.LEDEnable;

            cboDevice.SelectedValue = MyLayout.DeviceId;

            layoutStructBindingSource.Position = Last_Edited_Profil;

            radioAxe_0.Checked = true;

            MyNavInit(MyLayout.DeviceId);

            if (MainNav != null)
            {
                MainNav.OnButtonChanged += new HIDChangedEventHandler(myNav_OnButtonChanged);
                MainNav.SetModeConfig(true);
                MainNav.GetNavReport();
            }

        }

         void MyNavInit(int nPid)
         {
             if (myNav != null)
             {
                 myNav.OnButtonChanged -= myNav_OnButtonChanged;

             }
             myNav = null;
             myNav = SpaceNavigator.FindSpaceNav(nPid,8);
             if (myNav != null)
             {
                 myNav.OnButtonChanged += new HIDChangedEventHandler(myNav_OnButtonChanged);
             }


             
             radioAxe_0.Checked = true;
             radio_Click(radioAxe_0, null);

             grpSpaceNav.Visible = (nPid == 0xc626) | (nPid == 0xc621);
             grpPilot.Visible = (nPid == 0xc625);
             grpTraveler.Visible = (nPid == 0xc623);
             
         }


         void Init_CboKey()
         {
           
             AxePartBindingSource.DataSource = MyConst.MyBindFrom_AxePart_Txt;
             PressTypeBindingSource.DataSource = MyConst.MyBindFrom_FromType_Txt;
             BindToBindingSource.DataSource = MyConst.MyBindTo_Txt;
             JoyAxeBindingSource.DataSource = MyConst.MyBindTo_JoyAxe_Txt;
             JoyBtnBindingSource.DataSource = MyConst.MyBindTo_JoyBtn_Txt;
             JoyPOVBindingSource.DataSource = MyConst.MyBindTo_JoyPov_Txt;
             MouBtnBindingSource.DataSource = MyConst.MyBindTo_MouBtn_Txt;
             WWWBindingSource.DataSource = MyConst.MyBindTo_KeyWWW_Txt;
             DeviceBindingSource.DataSource = MyConst.MyDevice_Txt;
            
             cboKey.DataSource = MyConst.MyBindTo_Key_Txt.Clone();
             cboKey.DisplayMember = "Txt";
             cboKey.ValueMember = "Id";

             cboKey1.DataSource = MyConst.MyBindTo_KeyCode_Txt.Clone();
             cboKey1.DisplayMember = "Txt";
             cboKey1.ValueMember = "Id";

             cboKey2.DataSource = MyConst.MyBindTo_KeyCode_Txt.Clone(); 
             cboKey2.DisplayMember = "Txt";
             cboKey2.ValueMember = "Id";

             cboKey3.DataSource = MyConst.MyBindTo_KeyCode_Txt.Clone();
             cboKey3.DisplayMember = "Txt";
             cboKey3.ValueMember = "Id";

             cboKey4.DataSource = MyConst.MyBindTo_KeyCode_Txt.Clone();
             cboKey4.DisplayMember = "Txt";
             cboKey4.ValueMember = "Id";

             cboKey5.DataSource = MyConst.MyBindTo_KeyCode_Txt.Clone();
             cboKey5.DisplayMember = "Txt";
             cboKey5.ValueMember = "Id";

         }

         void Synchro_LayoutLst()
         {
            
             DefaultLayoutBindingSource.ResetBindings(false);
             ProfilLstBindingSource.ResetBindings(false);

             Synchro_AppLst();

         }
         void Synchro_AppLst()
         {
             
             if (layoutStructBindingSource.Current != null)
             {
               
                 layoutAppAutoBindingSource.DataSource = ((LayoutStruct)layoutStructBindingSource.Current)._AppAuto;
             }
             else
             {
                 layoutAppAutoBindingSource.DataSource = null;
             }
     
             layoutAppAutoBindingSource.ResetBindings(true);
         }

         void ShowSpaceNavOption()
         {
             if (MyBindFiltre.Count > 0)
             {
                 switch (BindFrom)
                 {
                     case BIND_FROM.BIND_FROM_AXE:
                         grpSpaceNavAxe.Visible = true;
                         break;

                     case BIND_FROM.BIND_FROM_BTN:
                         grpSpaceNavAxe.Visible = false;
                         break;
                 }
                 grpSpaceNavBtn.Visible = !grpSpaceNavAxe.Visible;

             }
             else
             {
                 grpSpaceNavAxe.Visible = false;
                 grpSpaceNavBtn.Visible = false;

                 cbo_AllOnOff();
             }

         }

         void Load_Bind()
         {
             MyBindFiltre.Clear();

             if (layoutStructBindingSource.Current != null)
             {

                 foreach (LayoutBind Bind in ((LayoutStruct)layoutStructBindingSource.Current)._Bind)
                 {
                     if ((Bind.BindFrom == BindFrom) && (Bind.BindFromNum == BindFromNum))
                     {
                         MyBindFiltre.Add(Bind);

                     }
                 }

                 if (MyBindFiltre.Count > 0)
                 {
                     layoutBindBindingSource.DataSource = MyBindFiltre;
                 }

             }
             layoutBindBindingSource.ResetBindings(false);

             layoutBindBindingSource.Position = 0;

             ShowSpaceNavOption();

         }

        void myNav_OnButtonChanged(object sender, HIDChangedEventArgs args)
        {

            CheckForIllegalCrossThreadCalls = false;

            lbl_X.Text = args.HIDValue.Axe[0].State_Current.ToString();
            lbl_Y.Text = args.HIDValue.Axe[1].State_Current.ToString();
            lbl_Z.Text = args.HIDValue.Axe[2].State_Current.ToString();
            lbl_rY.Text = args.HIDValue.Axe[3].State_Current.ToString();
            lbl_rX.Text = args.HIDValue.Axe[4].State_Current.ToString();
            lbl_rZ.Text = args.HIDValue.Axe[5].State_Current.ToString();
            pictureLeft.Visible = args.HIDValue.Btn[0].State_Current;
            pictureRight.Visible = args.HIDValue.Btn[1].State_Current;


            radioBtn_0_Pil.ImageIndex = args.HIDValue.Btn[0].State_Current ? 1 : 0;
            radioBtn_1_Pil.ImageIndex = args.HIDValue.Btn[1].State_Current ? 1 : 0; ;
            radioBtn_2_Pil.ImageIndex = args.HIDValue.Btn[2].State_Current ? 1 : 0; ;
            radioBtn_3_Pil.ImageIndex = args.HIDValue.Btn[3].State_Current ? 1 : 0; ;
            radioBtn_4_Pil.ImageIndex = args.HIDValue.Btn[4].State_Current ? 1 : 0; ;
            radioBtn_5_Pil.ImageIndex = args.HIDValue.Btn[5].State_Current ? 1 : 0; ;
            radioBtn_6_Pil.ImageIndex = args.HIDValue.Btn[6].State_Current ? 1 : 0; ;
            radioBtn_7_Pil.ImageIndex = args.HIDValue.Btn[7].State_Current ? 1 : 0; ;
            radioBtn_8_Pil.ImageIndex = args.HIDValue.Btn[8].State_Current ? 1 : 0; ;
            radioBtn_9_Pil.ImageIndex = args.HIDValue.Btn[9].State_Current ? 1 : 0; ;
            radioBtn_10_Pil.ImageIndex = args.HIDValue.Btn[10].State_Current ? 1 : 0; ;
            radioBtn_11_Pil.ImageIndex = args.HIDValue.Btn[11].State_Current ? 1 : 0; ;
            radioBtn_12_Pil.ImageIndex = args.HIDValue.Btn[12].State_Current ? 1 : 0; ;
            radioBtn_13_Pil.ImageIndex = args.HIDValue.Btn[13].State_Current ? 1 : 0; ;
            radioBtn_14_Pil.ImageIndex = args.HIDValue.Btn[14].State_Current ? 1 : 0; ;
            radioBtn_15_Pil.ImageIndex = args.HIDValue.Btn[15].State_Current ? 1 : 0; ;
            radioBtn_16_Pil.ImageIndex = args.HIDValue.Btn[16].State_Current ? 1 : 0; ;
            radioBtn_17_Pil.ImageIndex = args.HIDValue.Btn[17].State_Current ? 1 : 0; ;
            radioBtn_18_Pil.ImageIndex = args.HIDValue.Btn[18].State_Current ? 1 : 0; ;
            radioBtn_19_Pil.ImageIndex = args.HIDValue.Btn[19].State_Current ? 1 : 0; ;
            radioBtn_20_Pil.ImageIndex = args.HIDValue.Btn[20].State_Current ? 1 : 0; ;


            radioBtn_0_Trav.ImageIndex = args.HIDValue.Btn[0].State_Current ? 1 : 0; ;
            radioBtn_1_Trav.ImageIndex = args.HIDValue.Btn[1].State_Current ? 1 : 0; ;
            radioBtn_2_Trav.ImageIndex = args.HIDValue.Btn[2].State_Current ? 1 : 0; ;
            radioBtn_3_Trav.ImageIndex = args.HIDValue.Btn[3].State_Current ? 1 : 0; ;
            radioBtn_4_Trav.ImageIndex = args.HIDValue.Btn[4].State_Current ? 1 : 0; ;
            radioBtn_5_Trav.ImageIndex = args.HIDValue.Btn[5].State_Current ? 1 : 0; ;
            radioBtn_6_Trav.ImageIndex = args.HIDValue.Btn[6].State_Current ? 1 : 0; ;
            radioBtn_7_Trav.ImageIndex = args.HIDValue.Btn[7].State_Current ? 1 : 0; ;

            
        }
  
            
         private void trkDeadZone_Scroll_1(object sender, EventArgs e)
         {
             txtDeadZone.Text = ((TrackBar)sender).Value.ToString();

             if (layoutBindBindingSource.Current != null)
             {
                 if (((LayoutBind)layoutBindBindingSource.Current).BindFrom == BIND_FROM.BIND_FROM_AXE)
                 {
                     lblAxeDead.Text = Convert.ToString(((TrackBar)sender).Value + ((LayoutBind)layoutBindBindingSource.Current).DeadZone);
                 }
             }

         }
     
         private void layoutStructBindingSource_PositionChanged(object sender, EventArgs e)
         {
             Load_Bind();
             Synchro_AppLst();
            
         }


         private void Add_Bind()
         {
             if (layoutStructBindingSource.Current == null) return;

             LayoutBind NewBind = new LayoutBind(BindFrom, BindFromNum);

             ((LayoutStruct)layoutStructBindingSource.Current)._Bind.Add(NewBind);

             Load_Bind();

             layoutBindBindingSource.Position = layoutBindBindingSource.IndexOf(NewBind);
         }
     
         private void Del_Bind()
         {
             if (layoutBindBindingSource.Current != null)
             {


                 if (MessageBox.Show(
                  "<" + ((LayoutBind)layoutBindBindingSource.Current).BindTo_Txt + " - " +((LayoutBind)layoutBindBindingSource.Current).Comment + "> ?",
                  "Delete Bind",
                  MessageBoxButtons.YesNo)
                  == DialogResult.Yes)
                 {

                     ((LayoutStruct)layoutStructBindingSource.Current)._Bind.Remove(layoutBindBindingSource.Current);
                     layoutBindBindingSource.RemoveCurrent();

                     ShowSpaceNavOption();

                 }
             }
         }
         
         private void RBC9SpaceNav_FormClosed(object sender, FormClosedEventArgs e)
         {
           
             if (myNav != null)
             {
                myNav.OnButtonChanged -= myNav_OnButtonChanged;
      
             }

             if (MainNav != null)
             {
                 MainNav.OnButtonChanged -= myNav_OnButtonChanged;
                 MainNav.SetModeConfig(false);
                 MainNav.ReloadProfil();
                 // Led on
                 //MainNav.SetLed(true);
             }

         }


         private void trkMinVal_Scroll_1(object sender, EventArgs e)
         {
             TrackBar NewTrack = (TrackBar)sender;
             if (NewTrack.Value > trkMaxVal.Value)
                 NewTrack.Value = trkMaxVal.Value;

             lblMin.Text = NewTrack.Value.ToString();

         }

         private void trkMaxVal_Scroll_1(object sender, EventArgs e)
         {
             TrackBar NewTrack = (TrackBar)sender;
             if (NewTrack.Value < trkMinVal.Value)
                 NewTrack.Value = trkMinVal.Value;

             lblMax.Text = NewTrack.Value.ToString();
         }

         private void cbo_AllOnOff()
         {
             cbo_AllOnOff(false);
         }
         private void cbo_AllOnOff(bool Visible)
         {

             grpBindType.Visible = Visible;
             grpJoyAxe.Visible = Visible;
             grpJoyBtn.Visible = Visible;
             grpJoyPov.Visible = Visible;
             grpMouBtn.Visible = Visible;
             grpMouseSensi.Visible = Visible;
             grpLayout.Visible = Visible;
             grpKey.Visible = Visible;
             grpWWW.Visible = Visible;
             grpTypePress.Visible = Visible;
             grpTypeDelay.Visible = Visible;
             grpComment.Visible = Visible;
         }

         private void Show_Cbo()
         {
             BIND_TO MyBindTo;
        
             if (cboBintTo.SelectedItem == null) return;

             grpBindType.Visible = true;
             grpTypePress.Visible = true;
             grpComment.Visible = true;

             MyBindTo = (BIND_TO)((BaseLst)cboBintTo.SelectedItem).Id;
       
             grpJoyAxe.Visible = (MyBindTo == BIND_TO.BIND_TO_JOYSTICK_AXE);
             grpJoyBtn.Visible = (MyBindTo == BIND_TO.BIND_TO_JOYSTICK_BTN);
             grpJoyPov.Visible = (MyBindTo == BIND_TO.BIND_TO_JOYSTICK_POV);

             grpMouBtn.Visible = (MyBindTo == BIND_TO.BIND_TO_MOUSE_BTN);

             grpMouseSensi.Visible = ((MyBindTo == BIND_TO.BIND_TO_MOUSE_X)
                 || (MyBindTo == BIND_TO.BIND_TO_MOUSE_Y)
             || (MyBindTo == BIND_TO.BIND_TO_MOUSE_WHEEL));

             switch (MyBindTo)
             {
                 case BIND_TO.BIND_TO_MOUSE_X:
                     lblMouSensi.Text = "Sensitivity :";
                     lblMouSensiTaux.Text = "%";
                     break;

                 case BIND_TO.BIND_TO_MOUSE_Y:
                     lblMouSensi.Text = "Sensitivity :";
                     lblMouSensiTaux.Text = "%";
                     break;

                 case BIND_TO.BIND_TO_MOUSE_WHEEL:
                     lblMouSensi.Text = "Delay :";
                     lblMouSensiTaux.Text = " / 100 sec.";
                     break;

             }

             grpLayout.Visible = (MyBindTo == BIND_TO.BIND_TO_PROFIL);
          
             grpKey.Visible = (MyBindTo == BIND_TO.BIND_TO_KEYB);

             grpWWW.Visible = (MyBindTo == BIND_TO.BIND_TO_WWW);

             if (layoutStructBindingSource.Current != null)
             {
                 if (layoutBindBindingSource.Current != null)
                 {
                     if (((LayoutBind)layoutBindBindingSource.Current).BindFrom == BIND_FROM.BIND_FROM_AXE)
                     {
                         lblAxeDead.Text = Convert.ToString(((LayoutStruct)layoutStructBindingSource.Current).DeadZone + ((LayoutBind)layoutBindBindingSource.Current).DeadZone);
                     }
                 }
             }
             else
             {
                 lblAxeDead.Text = "";
             }

             if (cboPressType.SelectedValue != null)
             {
                 grpTypeDelay.Visible = ((PRESS_TYPE)cboPressType.SelectedValue != PRESS_TYPE.PRESS_STD);
             }
             else
             {
                 grpTypeDelay.Visible = false;
             }
             
         }

         private void cboBintTo_SelectionChangeCommitted(object sender, EventArgs e)
         {
             if (layoutBindBindingSource.Current != null)
             {

                 ((LayoutBind)layoutBindBindingSource.Current).BindTo = (BIND_TO)((BaseLst)cboBintTo.SelectedItem).Id;
                 layoutBindBindingSource.ResetCurrentItem();

             }
              
             Show_Cbo();
         }

         private void trkMouSensi_Scroll(object sender, EventArgs e)
         {
             TrackBar MyScroll = (TrackBar)sender;
             if (MyScroll.Value < 1)
             {
                 MyScroll.Value = 1;
             }
             ((LayoutBind)layoutBindBindingSource.Current).BindTo_MouSensi = (byte) MyScroll.Value;
             layoutBindBindingSource.ResetCurrentItem();
            
         }

     
        
         private void trkRepeat_Scroll(object sender, EventArgs e)
         {
             TrackBar MyScroll = (TrackBar)sender;
             if (MyScroll.Value < 10)
             {
                 MyScroll.Value = 10;
             }
             ((LayoutBind)layoutBindBindingSource.Current).BindTo_KeyDelay = (short)MyScroll.Value;
             layoutBindBindingSource.ResetCurrentItem();
         }

         private void gridLayout_CellValueChanged(object sender, DataGridViewCellEventArgs e)
         {
             Synchro_LayoutLst();
         }

         private void cboDefault_SelectedIndexChanged(object sender, EventArgs e)
         {
             ComboBox MyDefault = (ComboBox) sender;
             
             if (MyDefault.SelectedItem == null) return;

             MyLayout.Default_Profil = (short) MyDefault.SelectedValue;
         }

          
         private void radio_Click(object sender, EventArgs e)
         {
             if (sender == null) return;

             radioBtn_Nul_Nav.Checked = true;
             radioBtn_Nul_Pil.Checked = true;
             radioBtn_Nul_Axe.Checked = true;
             radioBtn_Nul_Trav.Checked = true;
             
             RadioButton MyRadio = (RadioButton)sender;
             
             MyRadio.Checked = true;

             switch (MyRadio.Tag.ToString().Substring(0, 3))
             {
                 case "Axe":
                     BindFrom = BIND_FROM.BIND_FROM_AXE;
                     break;

                 case "Btn":
                     BindFrom = BIND_FROM.BIND_FROM_BTN;
                     break;
             }

             BindFromNum = Convert.ToByte(MyRadio.Tag.ToString().Substring(4));

             Load_Bind();
         }


         private void btnApply_Click(object sender, EventArgs e)
         {

             if (MessageBox.Show(
                "Apply New Layout ?",
                "RBC9 - SpaceNavigator",
                MessageBoxButtons.YesNo)
                == DialogResult.Yes)
             {
                 
                 //Layout.Last_Profile = gridLayout.SelectedRows;
                 MyLayout.Save();
                 this.Close();

             }
          }

         private void btnCancel_Click(object sender, EventArgs e)
         {
             if (MessageBox.Show(
                "Quit without Save ?",
                "RBC9 - SpaceNavigator",
                MessageBoxButtons.YesNo)
                == DialogResult.Yes)
             {
                 this.Close();
             }

         }

         private void btnDelAppAuto_Click(object sender, EventArgs e)
         {
            
             if ( layoutAppAutoBindingSource.Current != null)
             {
                 if (MessageBox.Show(
                 "<" + ((BaseLst)layoutAppAutoBindingSource.Current).Txt + "> ?",
                 "Delete App",
                 MessageBoxButtons.YesNo)
                 == DialogResult.Yes)
                 {
                     layoutAppAutoBindingSource.RemoveCurrent();
                     
                 }
             }
         }

         private void btnAddAppAuto_Click(object sender, EventArgs e)
         {

             if (layoutStructBindingSource.Current == null) return;


             BaseLst NewApp = new BaseLst("< New App >", ((LayoutStruct)layoutStructBindingSource.Current).Profil_Id);

             ((LayoutStruct)layoutStructBindingSource.Current)._AppAuto.Add(NewApp);


             layoutAppAutoBindingSource.ResetBindings(true);
             layoutAppAutoBindingSource.Position = layoutAppAutoBindingSource.IndexOf(NewApp);
             
         }

         private void chkAutoApp_CheckedChanged(object sender, EventArgs e)
         {
             CheckBox MyAuto = (CheckBox)sender;

             if (MyAuto == null) return;

             MyLayout.AutoSwitch = MyAuto.Checked;
         }

         private void gridBindTo_SelectionChanged(object sender, EventArgs e)
         {

             MyLayout.Last_Profil = (short)layoutStructBindingSource.Position;
             //Synchro_LayoutLst();
             Show_Cbo();
         }

         private void btnCalib_Click(object sender, EventArgs e)
         {
             if (MessageBox.Show(
                "Calibrer ?",
                "RBC9 - SpaceNavigator",
                MessageBoxButtons.YesNo)
                == DialogResult.Yes)
             {
                 if (MainNav != null) MainNav.Calibrate();
             }
         }

         private void trkAxeZone_Scroll(object sender, EventArgs e)
         {
             TrackBar NewTrack = (TrackBar)sender;
             if (NewTrack.Value > trkAxeZone.Value)
                 NewTrack.Value = trkAxeZone.Value;

             lblAxeDead.Text = Convert.ToString(((LayoutStruct)layoutStructBindingSource.Current).DeadZone + NewTrack.Value);

         }

         private void gridBindTo_MouseClick(object sender, MouseEventArgs e)
         {
             if (e.Button == MouseButtons.Right)
             {
                 int CurrentRow = gridBindTo.HitTest(e.X, e.Y).RowIndex;
                 if (CurrentRow >= 0)
                 {
                     layoutBindBindingSource.Position = CurrentRow;

                     MenuBindCopy.Enabled = true;
                     MenuBindDel.Enabled = true;
                 }
                 else
                 {
                     MenuBindCopy.Enabled = false;
                     MenuBindDel.Enabled = false;
                 }

                 MenuBindPaste.Enabled = false;

                 if (layoutStructBindingSource.Current != null)
                 {
                     if (ClipBoardBind != null)
                     {
                             MenuBindPaste.Enabled = true;
                    }
                 }

                 MenuBind.Show(gridBindTo, e.Location);
             }
         }

         private void MenuBindDel_Click(object sender, EventArgs e)
         {
             Del_Bind();
         }

         private void MenuBindAdd_Click(object sender, EventArgs e)
         {
             Add_Bind();
         }

         private void MenuBindCopy_Click(object sender, EventArgs e)
         {

             if (layoutBindBindingSource.Current != null)
             {


                     ClipBoardBind = (LayoutBind)layoutBindBindingSource.Current;
                   

             }
         }

         private void MenuBindPaste_Click(object sender, EventArgs e)
         {
             if (MessageBox.Show(
                       "<" + ClipBoardBind.BindTo_Txt + " - " + ClipBoardBind .Comment + "> ?",
                       "Paste Bind",
                       MessageBoxButtons.YesNo)
                       == DialogResult.Yes)
             {

                 LayoutBind NewBind = new LayoutBind(ClipBoardBind.BindByte);
                 
                 if (NewBind.BindFrom != BindFrom) NewBind.BindFrom = BindFrom;
                 NewBind.BindFromNum = BindFromNum;
                 ((LayoutStruct)layoutStructBindingSource.Current)._Bind.Add(NewBind);

                 Load_Bind();

                 layoutBindBindingSource.Position = layoutBindBindingSource.IndexOf(NewBind);

             }
         }

         private void MenuLayoutAdd_Click(object sender, EventArgs e)
         {
             int NewPos = MyLayout.AddNewLayout();
             layoutStructBindingSource.ResetBindings(false);
             layoutStructBindingSource.Position = NewPos;
             Synchro_LayoutLst();
         }

         private void MenuLayoutDel_Click(object sender, EventArgs e)
         {
             if (layoutStructBindingSource.Current != null)
             {
                 if (MessageBox.Show(
                 "<" + ((LayoutStruct)layoutStructBindingSource.Current).Profil_Name + "> ?",
                 "Delete Layout",
                 MessageBoxButtons.YesNo)
                 == DialogResult.Yes)
                 {
                     layoutStructBindingSource.RemoveCurrent();
                     Synchro_LayoutLst();
                 }
             }
         }


         private void gridLayout_MouseClick(object sender, MouseEventArgs e)
         {
             if (e.Button == MouseButtons.Right)
             {
                 int CurrentRow = gridLayout.HitTest(e.X, e.Y).RowIndex;
                 if (CurrentRow >= 0)
                 {
                     layoutStructBindingSource.Position = CurrentRow;


                     MenuLayoutImport.Enabled = true;
                     MenuLayoutExport.Enabled = true;
                     MenuLayoutDuplicate.Enabled = true;
                     MenuLayoutDel.Enabled = true;
                 }
                 else
                 {
                     MenuLayoutImport.Enabled = false;
                     MenuLayoutExport.Enabled = false;
                     MenuLayoutDuplicate.Enabled = false;
                     MenuLayoutDel.Enabled = false;
                 }

                 MenuLayout.Show(gridLayout, e.Location);
             }
         }

         private void MenuLayoutDuplicate_Click(object sender, EventArgs e)
         {
             if (MessageBox.Show(
                "<" + ((LayoutStruct)layoutStructBindingSource.Current).Profil_Name + "> ?",
                "Duplicate Layout",
                MessageBoxButtons.YesNo)
                == DialogResult.Yes)
             {
                 int NewPos = MyLayout.Duplicate((LayoutStruct)layoutStructBindingSource.Current);
                 layoutStructBindingSource.ResetBindings(false);
                 layoutStructBindingSource.Position = NewPos;
                 Synchro_LayoutLst();
             }
             
         }

         private void MenuLayoutExport_Click(object sender, EventArgs e)
         {
                saveFileBind.FileName = ((LayoutStruct)layoutStructBindingSource.Current).Profil_Name;
                 if (saveFileBind.ShowDialog() == DialogResult.OK)
                 {
                     ((LayoutStruct)layoutStructBindingSource.Current).ExportBind(saveFileBind.FileName);
                 }
            

         }

         private void MenuLayoutImport_Click(object sender, EventArgs e)
         {
             openFileBind.FileName = "";
             if (openFileBind.ShowDialog() == DialogResult.OK)
             {
                 ((LayoutStruct)layoutStructBindingSource.Current).ImportBind(openFileBind.FileName);
             }
         }

         private void chkInfoBulle_CheckedChanged(object sender, EventArgs e)
         {
             CheckBox MyAuto = (CheckBox)sender;

             if (MyAuto == null) return;

             MyLayout.InfoBulle = MyAuto.Checked;
         }


         private void trkBtnDelay_Scroll(object sender, EventArgs e)
         {
           
             lblTypeDelay.Text = ((TrackBar)sender).Value.ToString();
            
         }

    

         private void BtnTypeBindingSource_CurrentChanged(object sender, EventArgs e)
         {
             grpTypeDelay.Visible = ((PRESS_TYPE)((BaseLst)PressTypeBindingSource.Current).Id != PRESS_TYPE.PRESS_STD);
         }

       

         private void cboBtnType_SelectionChangeCommitted(object sender, EventArgs e)
         {
             if (layoutBindBindingSource.Current != null)
             {

                 ((LayoutBind)layoutBindBindingSource.Current).FromType = (PRESS_TYPE)((BaseLst)cboPressType.SelectedItem).Id;
                 layoutBindBindingSource.ResetCurrentItem();

             }
         }

  

         private void cboDevice_SelectedIndexChanged(object sender, EventArgs e)
         {

             ComboBox MyDevice = (ComboBox)sender;

             if (MyDevice.SelectedItem == null) return;

             MyLayout.DeviceId = (int)MyDevice.SelectedValue;

             MyNavInit(MyLayout.DeviceId);
         }

         private void chkLEDEnable_CheckedChanged(object sender, EventArgs e)
         {
             CheckBox MyAuto = (CheckBox)sender;

             if (MyAuto == null) return;

             MyLayout.LEDEnable = MyAuto.Checked;
         }
 
                       
                      
    }
}